#!C:/Programs/Strawberry/win64/perl/bin/perl.exe -I"."

##############
# Simple Nim #
##############

use strict; use warnings;

use CGI;
use CGI::Carp "fatalsToBrowser";

my $cgi = new CGI;
print "Content-Type: text/html\n\n";
print '<!DOCTYPE html>', "\n\n";
# ------------------------------------------------------------
# Set $app_dir to the full path of the directory,
# where the template file "simplenim.template.html" is located
my $app_dir = "C:\\Programs\\Apache24\\htdocs";
# ------------------------------------------------------------
my $initialmatches; my $lastmatch; my $firstmove; my $level;
my $matches; my $remaining; my $matchesplayer; my $matchescomputer;
# Get parameters from 'calling' webpage and determine next button-push action
my %params = $cgi->Vars;
my $action = lc($params{'action'});
$action = 'init' unless ($action);
if ($action eq 'init' or $action eq 'new' or $action eq 'start' or $action eq 'play') {
  my $nextaction;
  if ($action eq 'init' or $action eq 'new') {
    # Prepare for a new game
    if ($action eq 'init') {
      # Defaults at first run
      $initialmatches = 15; $lastmatch = 'winner'; $firstmove = 'player'; $level = 1;
    }
    else {
      # Keeping settings from previous game
      $initialmatches = $params{'hinitialmatches'}; $lastmatch = $params{'hlastmatch'};
      $firstmove = $params{'hfirstmove'}; $level = $params{'hlevel'};
    }
    $matches = 0; $remaining = 0;
    $matchesplayer = 0; $matchescomputer = 0;
    $nextaction = 'start';
  }
  else {
    if ($action eq 'start') {
      # Start a new game (with parameters set by user)
      $initialmatches = $params{'initialmatches'}; $lastmatch = $params{'lastmatch'};
      $firstmove = $params{'firstmove'}; $level = $params{'level'};
      $matches = $initialmatches; $remaining = $matches;
      $matchesplayer = 0; $matchescomputer = 0;
    }
    else {
      # Play the game
      $initialmatches = $params{'hinitialmatches'}; $lastmatch = $params{'hlastmatch'};
      $firstmove = $params{'hfirstmove'}; $level = $params{'hlevel'};
      $matches = $params{'hmatches'}; $remaining = $params{'hremaining'};
      $matchesplayer = $params{'player'};                                      # get number of mateches taken by player
    }
    $nextaction = 'play';
  }
  # XSS protection: Potential risk characters removal and variable check (better being to careful than not enough...)
  $initialmatches =~ s/[^0-9]*//g;
  $matches =~ s/[^0-9]*//g;
  $remaining =~ s/[^0-9]*//g;
  $matchesplayer =~ s/[^1-3]//g;
  $matchescomputer =~ s/[^1-3]//g;
  $initialmatches = 15 unless ($initialmatches);
  $matches = 0 unless ($matches);
  $remaining = 0 unless ($remaining);
  $matchesplayer = 0 unless ($matchesplayer);
  $matchescomputer = 0 unless ($matchescomputer);
  $lastmatch = 'winner' unless ($lastmatch eq 'looser');
  $firstmove = 'player' unless ($firstmove eq 'computer');
  $level = 1 unless ($level == 2 or $level == 3);
  # Do action, depending on the actual button caption ('Start' or 'Play')
  my $winner = '';
  if ($action eq 'start' or $action eq 'play') {
    if ($action eq 'start') {
      # If the computer has to move first, do the move (otherwise just generate the webpage)
      if ($firstmove eq 'computer') {
        $matches = $remaining;
        $matchescomputer = ComputerMove($remaining, $lastmatch, $level);
        $remaining = $matches - $matchescomputer;                              # matches remaining after computer's move
      }
    }
    elsif ($action eq 'play') {
      # Determine matches remaining after player's move. If all matches have been taken, the game is over.
      # Otherwise, do computer's move
      $matches = $remaining;
      $remaining -= $matchesplayer;                                            # matches remaining after player's move
      if ($remaining == 0) {
        # No match remaining: Player has taken last match
        if ($lastmatch eq 'winner') {
          $winner = 'The player takes the last match and wins!';
        }
        else {
          $winner = 'The player takes the last match and looses!';
        }
      }
      else {
        # One or more matches remaining: Do computer's move
        $matchescomputer = ComputerMove($remaining, $lastmatch, $level);
        $remaining -= $matchescomputer;                                        # matches remaining after computer's move
        if ($remaining == 0) {
          # No match remaining: Computer has taken last match
          if ($lastmatch eq 'winner') {
            $winner = 'The computer takes the last match and wins!';
          }
          else {
            $winner = 'The computer takes the last match and looses!';
          }
        }
      }
    }
    if ($winner) {
      # If game is over, next action will be preparation for a new game
      $nextaction = 'new';
    }
  }
  # Read template HTML file
  my $template = "$app_dir\\simplenim.template.html";
  open(my $input, "<", $template)
    or die "Can't open template file $template: $!";
  my @lines = <$input>;
  close($input);
  # Create the webpage, printing the template, replacing all #-tags by the actual values
  my $matchcount = 0;
  foreach my $line (@lines) {
    chomp($line);
    if ($line) {
      if (substr($line, 0, 1) eq '#') {                                        # A '#' at beginning of line indicates that line contains a tag
        $line = substr($line, 1);
        if ($line =~ /#initialmatches#/) {
          # Initial number of matches
          $line =~ s/#initialmatches#/$initialmatches/;
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#readonly#//;
          }
          else {
            $line =~ s/#readonly#/readonly="readonly"/;                        # disable modification of initial matches number during game
          }
        }
        elsif ($line =~ /#checked1a#/) {
          # Last match = Winner radio button
          if ($lastmatch eq 'winner') {
            $line =~ s/#checked1a#/checked="checked"/;
          }
          else {
            $line =~ s/#checked1a#//;
          }
        }
        elsif ($line =~ /#checked1b#/) {
          # Last match = Looser radio button
          if ($lastmatch eq 'looser') {
            $line =~ s/#checked1b#/checked="checked"/;
          }
          else {
            $line =~ s/#checked1b#//;
          }
        }
        elsif ($line =~ /#checked2a#/) {
          # First move = Player radio button
          if ($firstmove eq 'player') {
            $line =~ s/#checked2a#/checked="checked"/;
          }
          else {
            $line =~ s/#checked2a#//;
          }
        }
        elsif ($line =~ /#checked2b#/) {
          # First move = Computer radio button
          if ($firstmove eq 'computer') {
            $line =~ s/#checked2b#/checked="checked"/;
          }
          else {
            $line =~ s/#checked2b#//;
          }
        }
        elsif ($line =~ /#selected1#/) {
          # Computer strength = Novice
          if ($level == 1) {
            $line =~ s/#selected1#/selected="selected"/;
          }
          else {
            $line =~ s/#selected1#//;
          }
        }
        elsif ($line =~ /#selected2#/) {
          # Computer strength = Intermediate
          if ($level == 2) {
            $line =~ s/#selected2#/selected="selected"/;
          }
          else {
            $line =~ s/#selected2#//;
          }
        }
        elsif ($line =~ /#selected3#/) {
          # Computer strength = Expert
          if ($level == 3) {
            $line =~ s/#selected3#/selected="selected"/;
          }
          else {
            $line =~ s/#selected3#//;
          }
        }
        elsif ($line =~ /#visible#/) {
          # Show actual matches (by hiding those already taken)
          $matchcount++;
          my $visible = 'style="visibility:';
          my $matchesdisplayed;
          if ($action eq 'init' or $action eq 'new') {
            $matchesdisplayed = $initialmatches;                               # show all matches
          }
          else {
            $matchesdisplayed = $remaining;                                    # show as many matches as there are left
          }
          if ($matchcount <= $matchesdisplayed) {
            $visible .= 'visible"';
          }
          else {
            $visible .= 'hidden"';
          }
          $line =~ s/#visible#/$visible/;
        }
        elsif ($line =~ /#matches#/) {
          # Number of matches (before there have been matches taken)
          if ($matches == 0) {
            $line =~ s/#matches#//;
          }
          else {
            $line =~ s/#matches#/$matches/;
          }
        }
        elsif ($line =~ /#remaining#/) {
          # Number of matches (after there have been matches taken)
          if ($remaining == 0 and $winner eq '') {
            $line =~ s/#remaining#//;
          }
          else {
            $line =~ s/#remaining#/$remaining/;
          }
        }
        elsif ($line =~ /#player#/) {
          # Number of matches taken by the player
          if ($matchesplayer == 0) {
            $line =~ s/#player#//;
          }
          else {
            $line =~ s/#player#/$matchesplayer/;
          }
          if ($nextaction eq 'play') {
            # During play, the input field must be accessible for user input
            $line =~ s/#readonly#//;
            my $bold = 'style="font-weight: bold"';
            $line =~ s/#bold#/$bold/;
          }
          else {
            # Do not allow user input if the game isn't actually running
            $line =~ s/#readonly#/readonly="readonly"/;
            $line =~ s/#bold#//;
          }
        }
        elsif ($line =~ /#computer#/) {
          # Number of matches taken by the computer
          if ($matchescomputer == 0) {
            $line =~ s/#computer#//;
          }
          else {
            $line =~ s/#computer#/$matchescomputer/;
          }
        }
        elsif ($line =~ /#button#/) {
          # Action button caption
          my $button = ucfirst($nextaction);
          $line =~ s/#button#/$button/;                                        # set button caption to next action
        }
        elsif ($line =~ /#hinitialmatches#/) {
          # Hidden save field for initial number of matches
          $line =~ s/#hinitialmatches#/$initialmatches/;
        }
        elsif ($line =~ /#hlastmatch#/) {
          # Hidden save field for last match rule
          $line =~ s/#hlastmatch#/$lastmatch/;
        }
        elsif ($line =~ /#hfirstmove#/) {
          # Hidden save field for game beginner
          $line =~ s/#hfirstmove#/$firstmove/;
        }
        elsif ($line =~ /#hlevel#/) {
          # Hidden save field for computer strength
          $line =~ s/#hlevel#/$level/;
        }
        elsif ($line =~ /#hmatches#/) {
          # Hidden save field for number of matches (before there have been matches taken)
          $line =~ s/#hmatches#/$matches/;
        }
        elsif ($line =~ /#hremaining#/) {
          # Hidden save field for number of matches (after there have been matches taken)
          $line =~ s/#hremaining#/$remaining/;
        }
        elsif ($line =~ /#hplayer#/) {
          # Hidden save field for number of matches taken by the player
          $line =~ s/#hplayer#/$matchesplayer/;
        }
        elsif ($line =~ /#js#/) {
          # Add Javascript code to perform some action when the page is displayed
          my $js;
          if ($nextaction eq 'play' and $winner eq '') {
            # Javascript to focus the 'number of matches taken by player' input field
            $js = "<script>document.getElementById('player').focus();</script>";
          }
          elsif ($winner ne '') {
            # Javascript to pop-up a message, telling who wins/looses the game
            $js = "<script>alert('$winner');</script>";
          }
          else {
            $js = '';
          }
          $line =~ s/#js#/$js/;
        }
      }
    }
    # Print file-line (with tags replaced) to webpage
    unless ($line =~ /#/) {
      print "$line\n";
    }
  }
}

# ------------------------------------------------------------------------------- #
# Do the computer's move (depending on actual last-match-rule and strength level) #
# ------------------------------------------------------------------------------- #

sub ComputerMove {
  my ($matches, $last, $level) = @_;
  my $computer = int(rand(3) + 1);                                             # random number of matches
  unless ($level == 1) {                                                       # level 1: all moves are random
    my $bestmove = 1;
    if ($level == 2) {
      if ($matches >= $initialmatches / 2) {
        # First half of game: Random move or not (1 out of 3); full strength during second half of game
        if (int(rand(3)) == 0) {
          $bestmove = 0;
        }
      }
    }
    if ($bestmove) {
      # Check if there is a winning move. If yes, do it
      # The winning algorithm is simplistic:
      # If the last match wins, the number of matches left after the move must be a multiple of 4
      # If the last match looses, the number of matches left after the move must be a multiple of 4 plus 1
      my $modulo;
      if ($lastmatch eq 'winner') {
        $modulo = 0;
      }
      else {
        $modulo = 1;
      }
      for (my $i = 1; $i <= 3; $i++) {
        if (($matches - $i) % 4 == $modulo) {
          # If taking 1, 2 or 3 matches results in a winning position, do this move (otherwise keep the random number of matches)
          $computer = $i;
        }
      }
    }
  }
  if ($computer > $matches) {
    $computer = $matches;                                                      # cannot take more matches than there are left
  }
  return $computer;
}
